diff --git a/python/psutil/test/_osx.py b/python/psutil/test/_osx.py
index 6e6e4380ef..30fafea7bb 100644
--- a/python/psutil/test/_osx.py
+++ b/python/psutil/test/_osx.py
@@ -44,7 +44,7 @@ def vm_stat(field):
             break
     else:
         raise ValueError("line not found")
-    return int(re.search('\d+', line).group(0)) * PAGESIZE
+    return int(re.search(r'\d+', line).group(0)) * PAGESIZE
 
 
 @unittest.skipUnless(OSX, "not an OSX system")
@@ -151,7 +151,7 @@ class OSXSpecificTestCase(unittest.TestCase):
 
 def main():
     test_suite = unittest.TestSuite()
-    test_suite.addTest(unittest.makeSuite(OSXSpecificTestCase))
+    test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(OSXSpecificTestCase))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
diff --git a/python/psutil/test/_posix.py b/python/psutil/test/_posix.py
index e6c56aac3e..be9f0d6497 100644
--- a/python/psutil/test/_posix.py
+++ b/python/psutil/test/_posix.py
@@ -192,7 +192,7 @@ class PosixSpecificTestCase(unittest.TestCase):
                     break
             else:
                 self.fail(
-                    "couldn't find %s nic in 'ifconfig -a' output\n%s" % (
+                    "couldn't find {} nic in 'ifconfig -a' output\n{}".format(
                         nic, output))
 
     @retry_before_failing()
@@ -249,7 +249,7 @@ class PosixSpecificTestCase(unittest.TestCase):
 
 def main():
     test_suite = unittest.TestSuite()
-    test_suite.addTest(unittest.makeSuite(PosixSpecificTestCase))
+    test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(PosixSpecificTestCase))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
diff --git a/python/psutil/test/_sunos.py b/python/psutil/test/_sunos.py
index 3d54ccd8cf..3f99f01ab5 100644
--- a/python/psutil/test/_sunos.py
+++ b/python/psutil/test/_sunos.py
@@ -39,7 +39,7 @@ class SunOSSpecificTestCase(unittest.TestCase):
 
 def main():
     test_suite = unittest.TestSuite()
-    test_suite.addTest(unittest.makeSuite(SunOSSpecificTestCase))
+    test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(SunOSSpecificTestCase))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
diff --git a/python/psutil/test/_windows.py b/python/psutil/test/_windows.py
index b7477bfeb4..eab325f6fa 100644
--- a/python/psutil/test/_windows.py
+++ b/python/psutil/test/_windows.py
@@ -18,7 +18,7 @@ import traceback
 from test_psutil import APPVEYOR, WINDOWS
 from test_psutil import get_test_subprocess, reap_children, unittest
 
-import mock
+from unittest import mock
 try:
     import wmi
 except ImportError:
@@ -29,7 +29,7 @@ try:
 except ImportError:
     win32api = win32con = None
 
-from psutil._compat import PY3, callable, long
+from psutil._compat import PY3, callable, int
 import psutil
 
 
@@ -91,7 +91,7 @@ class WindowsSpecificTestCase(unittest.TestCase):
         out = p.communicate()[0]
         if PY3:
             out = str(out, sys.stdout.encoding)
-        nics = psutil.net_io_counters(pernic=True).keys()
+        nics = list(psutil.net_io_counters(pernic=True).keys())
         for nic in nics:
             if "pseudo-interface" in nic.replace(' ', '-').lower():
                 continue
@@ -134,7 +134,7 @@ class WindowsSpecificTestCase(unittest.TestCase):
         w = wmi.WMI().Win32_Process(ProcessId=self.pid)[0]
         p = psutil.Process(self.pid)
         domain, _, username = w.GetOwner()
-        username = "%s\\%s" % (domain, username)
+        username = "{}\\{}".format(domain, username)
         self.assertEqual(p.username(), username)
 
     @unittest.skipIf(wmi is None, "wmi module is not installed")
@@ -157,7 +157,7 @@ class WindowsSpecificTestCase(unittest.TestCase):
         # returned instead.
         wmi_usage = int(w.PageFileUsage)
         if (vms != wmi_usage) and (vms != wmi_usage * 1024):
-            self.fail("wmi=%s, psutil=%s" % (wmi_usage, vms))
+            self.fail("wmi={}, psutil={}".format(wmi_usage, vms))
 
     @unittest.skipIf(wmi is None, "wmi module is not installed")
     def test_process_create_time(self):
@@ -201,7 +201,7 @@ class WindowsSpecificTestCase(unittest.TestCase):
         # Note: this test might fail if the OS is starting/killing
         # other processes in the meantime
         w = wmi.WMI().Win32_Process()
-        wmi_pids = set([x.ProcessId for x in w])
+        wmi_pids = {x.ProcessId for x in w}
         psutil_pids = set(psutil.pids())
         self.assertEqual(wmi_pids, psutil_pids)
 
@@ -228,7 +228,7 @@ class WindowsSpecificTestCase(unittest.TestCase):
                     self.assertEqual(usage.free, wmi_free)
                     # 10 MB tollerance
                     if abs(usage.free - wmi_free) > 10 * 1024 * 1024:
-                        self.fail("psutil=%s, wmi=%s" % (
+                        self.fail("psutil={}, wmi={}".format(
                             usage.free, wmi_free))
                     break
             else:
@@ -282,8 +282,7 @@ class WindowsSpecificTestCase(unittest.TestCase):
             self.fail('\n' + '\n'.join(failures))
 
     def test_name_always_available(self):
-        # On Windows name() is never supposed to raise AccessDenied,
-        # see https://github.com/giampaolo/psutil/issues/627
+        # On Windows name() is never supposed to raise AccessDenied(# see https://github.com/giampaolo/psutil/issues/627)
         for p in psutil.process_iter():
             try:
                 p.name()
@@ -317,7 +316,7 @@ class TestDualProcessImplementation(unittest.TestCase):
             if isinstance(obj, tuple):
                 for value in obj:
                     self.assertGreaterEqual(value, 0, msg=obj)
-            elif isinstance(obj, (int, long, float)):
+            elif isinstance(obj, (int, int, float)):
                 self.assertGreaterEqual(obj, 0)
             else:
                 assert 0  # case not handled which needs to be fixed
@@ -326,7 +325,7 @@ class TestDualProcessImplementation(unittest.TestCase):
             if ret1 == ret2:
                 return
             else:
-                if isinstance(ret2, (int, long, float)):
+                if isinstance(ret2, (int, int, float)):
                     diff = abs(ret1 - ret2)
                     self.assertLessEqual(diff, tolerance)
                 elif isinstance(ret2, tuple):
@@ -376,7 +375,7 @@ class TestDualProcessImplementation(unittest.TestCase):
                         compare_with_tolerance(ret, rawtupl, tolerance)
                 except AssertionError:
                     trace = traceback.format_exc()
-                    msg = '%s\npid=%s, method=%r, ret_1=%r, ret_2=%r' % (
+                    msg = '{}\npid={}, method={!r}, ret_1={!r}, ret_2={!r}'.format(
                         trace, p.pid, name, ret, nt)
                     failures.append(msg)
                     break
@@ -454,8 +453,8 @@ class TestDualProcessImplementation(unittest.TestCase):
 
 def main():
     test_suite = unittest.TestSuite()
-    test_suite.addTest(unittest.makeSuite(WindowsSpecificTestCase))
-    test_suite.addTest(unittest.makeSuite(TestDualProcessImplementation))
+    test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(WindowsSpecificTestCase))
+    test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(TestDualProcessImplementation))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
diff --git a/python/psutil/test/test_memory_leaks.py b/python/psutil/test/test_memory_leaks.py
index 6f02dc0acf..879d3c5748 100644
--- a/python/psutil/test/test_memory_leaks.py
+++ b/python/psutil/test/test_memory_leaks.py
@@ -48,7 +48,7 @@ class Base(unittest.TestCase):
 
     def execute(self, function, *args, **kwargs):
         def call_many_times():
-            for x in xrange(LOOPS - 1):
+            for x in range(LOOPS - 1):
                 self.call(function, *args, **kwargs)
             del x
             gc.collect()
@@ -436,7 +436,7 @@ def main():
              TestProcessObjectLeaks,
              TestModuleFunctionsLeaks]
     for test in tests:
-        test_suite.addTest(unittest.makeSuite(test))
+        test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(test))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
diff --git a/python/psutil/test/test_psutil.py b/python/psutil/test/test_psutil.py
index 3b2e3587ae..da180081f8 100644
--- a/python/psutil/test/test_psutil.py
+++ b/python/psutil/test/test_psutil.py
@@ -1,5 +1,4 @@
 #!/usr/bin/env python
-# -*- coding: utf-8 -*-
 
 # Copyright (c) 2009, Giampaolo Rodola'. All rights reserved.
 # Use of this source code is governed by a BSD-style license that can be
@@ -13,7 +12,6 @@ If you're on Python < 2.7 unittest2 module must be installed first:
 https://pypi.python.org/pypi/unittest2
 """
 
-from __future__ import division
 
 import ast
 import atexit
@@ -50,10 +48,10 @@ except ImportError:
 try:
     from unittest import mock  # py3
 except ImportError:
-    import mock  # requires "pip install mock"
+    from unittest import mock
 
 import psutil
-from psutil._compat import PY3, callable, long, unicode
+from psutil._compat import PY3, callable, int, str
 
 if sys.version_info < (2, 7):
     import unittest2 as unittest  # https://pypi.python.org/pypi/unittest2
@@ -85,7 +83,7 @@ TESTFN_UNICODE = TESTFN + "ƒőő"
 TESTFILE_PREFIX = 'psutil-test-suite-'
 if not PY3:
     try:
-        TESTFN_UNICODE = unicode(TESTFN_UNICODE, sys.getfilesystemencoding())
+        TESTFN_UNICODE = str(TESTFN_UNICODE, sys.getfilesystemencoding())
     except UnicodeDecodeError:
         TESTFN_UNICODE = TESTFN + "???"
 
@@ -273,14 +271,14 @@ def wait_for_file(fname, timeout=GLOBAL_TIMEOUT, delete_file=True):
     stop_at = time.time() + 3
     while time.time() < stop_at:
         try:
-            with open(fname, "r") as f:
+            with open(fname) as f:
                 data = f.read()
             if not data:
                 continue
             if delete_file:
                 os.remove(fname)
             return data
-        except IOError:
+        except OSError:
             time.sleep(0.001)
     raise RuntimeError("timed out (couldn't read file)")
 
@@ -325,16 +323,16 @@ def check_ip_address(addr, family):
             assert 0 <= num <= 255, addr
         if ipaddress:
             if not PY3:
-                addr = unicode(addr)
+                addr = str(addr)
             ipaddress.IPv4Address(addr)
     elif family == AF_INET6:
         assert isinstance(addr, str), addr
         if ipaddress:
             if not PY3:
-                addr = unicode(addr)
+                addr = str(addr)
             ipaddress.IPv6Address(addr)
     elif family == psutil.AF_LINK:
-        assert re.match('([a-fA-F0-9]{2}[:|\-]?){6}', addr) is not None, addr
+        assert re.match(r'([a-fA-F0-9]{2}[:|\-]?){6}', addr) is not None, addr
     else:
         raise ValueError("unknown family %r", family)
 
@@ -378,7 +376,7 @@ def check_connection_ntuple(conn):
             with contextlib.closing(s):
                 try:
                     s.bind((conn.laddr[0], 0))
-                except socket.error as err:
+                except OSError as err:
                     if err.errno != errno.EADDRNOTAVAIL:
                         raise
     elif conn.family == AF_UNIX:
@@ -390,7 +388,7 @@ def check_connection_ntuple(conn):
         if hasattr(socket, 'fromfd') and not WINDOWS:
             try:
                 dupsock = socket.fromfd(conn.fd, conn.family, conn.type)
-            except (socket.error, OSError) as err:
+            except OSError as err:
                 if err.args[0] != errno.EBADF:
                     raise
             else:
@@ -494,7 +492,7 @@ def supports_ipv6():
     try:
         sock = socket.socket(AF_INET6, SOCK_STREAM)
         sock.bind(("::1", 0))
-    except (socket.error, socket.gaierror):
+    except (OSError, socket.gaierror):
         return False
     else:
         return True
@@ -509,7 +507,7 @@ if WINDOWS:
         if hasattr(wv, 'service_pack_major'):  # python >= 2.7
             sp = wv.service_pack_major or 0
         else:
-            r = re.search("\s\d$", wv[4])
+            r = re.search(r"\s\d$", wv[4])
             if r:
                 sp = int(r.group(0))
             else:
@@ -528,7 +526,7 @@ class ThreadTask(threading.Thread):
 
     def __repr__(self):
         name = self.__class__.__name__
-        return '<%s running=%s at %#x>' % (name, self._running, id(self))
+        return '<{} running={} at {:#x}>'.format(name, self._running, id(self))
 
     def start(self, interval=0.001):
         """Start thread and keep it running until an explicit
@@ -627,7 +625,7 @@ class TestSystemAPIs(unittest.TestCase):
         sproc1.terminate()
         sproc2.terminate()
         gone, alive = test(procs, callback)
-        self.assertEqual(set(l), set([sproc1.pid, sproc2.pid, sproc3.pid]))
+        self.assertEqual(set(l), {sproc1.pid, sproc2.pid, sproc3.pid})
         for p in gone:
             self.assertTrue(hasattr(p, 'returncode'))
 
@@ -664,10 +662,10 @@ class TestSystemAPIs(unittest.TestCase):
         for name in mem._fields:
             value = getattr(mem, name)
             if name != 'percent':
-                self.assertIsInstance(value, (int, long))
+                self.assertIsInstance(value, int)
             if name != 'total':
                 if not value >= 0:
-                    self.fail("%r < 0 (%s)" % (name, value))
+                    self.fail("{!r} < 0 ({})".format(name, value))
                 if value > mem.total:
                     self.fail("%r > total (total=%s, %s=%s)"
                               % (name, mem.total, name, value))
@@ -709,7 +707,7 @@ class TestSystemAPIs(unittest.TestCase):
                 time.sleep(.1)
                 if pid in psutil.pids():
                     self.fail(pid)
-        pids = range(max(pids) + 5000, max(pids) + 6000)
+        pids = list(range(max(pids) + 5000, max(pids) + 6000))
         for pid in pids:
             self.assertFalse(psutil.pid_exists(pid), msg=pid)
 
@@ -764,7 +762,7 @@ class TestSystemAPIs(unittest.TestCase):
                     new_t = getattr(new, field)
                     last_t = getattr(last, field)
                     self.assertGreaterEqual(new_t, last_t,
-                                            msg="%s %s" % (new_t, last_t))
+                                            msg="{} {}".format(new_t, last_t))
                 last = new
 
     def test_sys_cpu_times2(self):
@@ -828,7 +826,7 @@ class TestSystemAPIs(unittest.TestCase):
             self.assertIsNot(percent, -0.0)
             self.assertLessEqual(percent, 100.0 * psutil.cpu_count())
         except AssertionError as err:
-            raise AssertionError("\n%s\nlast=%s\nnew=%s" % (
+            raise AssertionError("\n{}\nlast={}\nnew={}".format(
                 err, pprint.pformat(last_ret), pprint.pformat(new_ret)))
 
     def test_sys_cpu_percent(self):
@@ -1034,7 +1032,7 @@ class TestSystemAPIs(unittest.TestCase):
         # self.assertEqual(sorted(nics.keys()),
         #                  sorted(psutil.net_io_counters(pernic=True).keys()))
 
-        families = set([socket.AF_INET, AF_INET6, psutil.AF_LINK])
+        families = {socket.AF_INET, AF_INET6, psutil.AF_LINK}
         for nic, addrs in nics.items():
             self.assertEqual(len(set(addrs)), len(addrs))
             for addr in addrs:
@@ -1120,7 +1118,7 @@ class TestSystemAPIs(unittest.TestCase):
                 # https://github.com/giampaolo/psutil/issues/338
                 while key[-1].isdigit():
                     key = key[:-1]
-                self.assertNotIn(key, ret.keys())
+                self.assertNotIn(key, list(ret.keys()))
 
     def test_users(self):
         users = psutil.users()
@@ -1326,10 +1324,10 @@ class TestProcess(unittest.TestCase):
         # using a tolerance  of +/- 0.1 seconds.
         # It will fail if the difference between the values is > 0.1s.
         if (max([user_time, utime]) - min([user_time, utime])) > 0.1:
-            self.fail("expected: %s, found: %s" % (utime, user_time))
+            self.fail("expected: {}, found: {}".format(utime, user_time))
 
         if (max([kernel_time, ktime]) - min([kernel_time, ktime])) > 0.1:
-            self.fail("expected: %s, found: %s" % (ktime, kernel_time))
+            self.fail("expected: {}, found: {}".format(ktime, kernel_time))
 
     def test_create_time(self):
         sproc = get_test_subprocess(wait=True)
@@ -1422,13 +1420,13 @@ class TestProcess(unittest.TestCase):
                 self.assertRaises(ValueError, p.ionice, 2, -1)
                 self.assertRaises(ValueError, p.ionice, 4)
                 self.assertRaises(TypeError, p.ionice, 2, "foo")
-                self.assertRaisesRegexp(
+                self.assertRaisesRegex(
                     ValueError, "can't specify value with IOPRIO_CLASS_NONE",
                     p.ionice, psutil.IOPRIO_CLASS_NONE, 1)
-                self.assertRaisesRegexp(
+                self.assertRaisesRegex(
                     ValueError, "can't specify value with IOPRIO_CLASS_IDLE",
                     p.ionice, psutil.IOPRIO_CLASS_IDLE, 1)
-                self.assertRaisesRegexp(
+                self.assertRaisesRegex(
                     ValueError, "'ioclass' argument must be specified",
                     p.ionice, value=1)
             finally:
@@ -1578,7 +1576,7 @@ class TestProcess(unittest.TestCase):
                 elif fname in ('addr', 'perms'):
                     assert value, value
                 else:
-                    self.assertIsInstance(value, (int, long))
+                    self.assertIsInstance(value, int)
                     assert value >= 0, value
 
     def test_memory_percent(self):
@@ -1611,7 +1609,7 @@ class TestProcess(unittest.TestCase):
                 # "/usr/local/bin/python"
                 # We do not want to consider this difference in accuracy
                 # an error.
-                ver = "%s.%s" % (sys.version_info[0], sys.version_info[1])
+                ver = "{}.{}".format(sys.version_info[0], sys.version_info[1])
                 self.assertEqual(exe.replace(ver, ''), PYTHON.replace(ver, ''))
 
     def test_cmdline(self):
@@ -1779,7 +1777,7 @@ class TestProcess(unittest.TestCase):
         p.cpu_affinity(tuple(all_cpus))
         invalid_cpu = [len(psutil.cpu_times(percpu=True)) + 10]
         self.assertRaises(ValueError, p.cpu_affinity, invalid_cpu)
-        self.assertRaises(ValueError, p.cpu_affinity, range(10000, 11000))
+        self.assertRaises(ValueError, p.cpu_affinity, list(range(10000, 11000)))
         self.assertRaises(TypeError, p.cpu_affinity, [0, "1"])
 
     # TODO
@@ -2085,7 +2083,7 @@ class TestProcess(unittest.TestCase):
             except psutil.Error:
                 pass
         # this is the one, now let's make sure there are no duplicates
-        pid = sorted(table.items(), key=lambda x: x[1])[-1][0]
+        pid = sorted(list(table.items()), key=lambda x: x[1])[-1][0]
         p = psutil.Process(pid)
         try:
             c = p.children(recursive=True)
@@ -2173,7 +2171,7 @@ class TestProcess(unittest.TestCase):
                 pass
             else:
                 self.fail(
-                    "NoSuchProcess exception not raised for %r, retval=%s" % (
+                    "NoSuchProcess exception not raised for {!r}, retval={}".format(
                         name, ret))
 
     @unittest.skipUnless(POSIX, 'posix only')
@@ -2280,7 +2278,7 @@ class TestProcess(unittest.TestCase):
             except psutil.AccessDenied:
                 pass
 
-            self.assertRaisesRegexp(
+            self.assertRaisesRegex(
                 ValueError, "preventing sending signal to process with PID 0",
                 p.send_signal, signal.SIGTERM)
 
@@ -2344,14 +2342,14 @@ class TestFetchAllProcesses(unittest.TestCase):
         if POSIX:
             import pwd
             pall = pwd.getpwall()
-            self._uids = set([x.pw_uid for x in pall])
-            self._usernames = set([x.pw_name for x in pall])
+            self._uids = {x.pw_uid for x in pall}
+            self._usernames = {x.pw_name for x in pall}
 
     def test_fetch_all(self):
         valid_procs = 0
-        excluded_names = set([
+        excluded_names = {
             'send_signal', 'suspend', 'resume', 'terminate', 'kill', 'wait',
-            'as_dict', 'cpu_percent', 'parent', 'children', 'pid'])
+            'as_dict', 'cpu_percent', 'parent', 'children', 'pid'}
         if LINUX and not RLIMIT_SUPPORT:
             excluded_names.add('rlimit')
         attrs = []
@@ -2397,7 +2395,7 @@ class TestFetchAllProcesses(unittest.TestCase):
                         meth(ret)
                 except Exception as err:
                     s = '\n' + '=' * 70 + '\n'
-                    s += "FAIL: test_%s (proc=%s" % (name, p)
+                    s += "FAIL: test_{} (proc={}".format(name, p)
                     if ret != default:
                         s += ", ret=%s)" % repr(ret)
                     s += ')\n'
@@ -2434,7 +2432,7 @@ class TestFetchAllProcesses(unittest.TestCase):
         self.assertTrue(ret >= 0)
 
     def name(self, ret):
-        self.assertIsInstance(ret, (str, unicode))
+        self.assertIsInstance(ret, (str, str))
         self.assertTrue(ret)
 
     def create_time(self, ret):
@@ -2568,7 +2566,7 @@ class TestFetchAllProcesses(unittest.TestCase):
                 elif fname in ('addr', 'perms'):
                     self.assertTrue(value)
                 else:
-                    self.assertIsInstance(value, (int, long))
+                    self.assertIsInstance(value, int)
                     assert value >= 0, value
 
     def num_handles(self, ret):
@@ -2743,7 +2741,7 @@ class TestMisc(unittest.TestCase):
         self.assertNotEqual(p1, 'foo')
 
     def test_process__hash__(self):
-        s = set([psutil.Process(), psutil.Process()])
+        s = {psutil.Process(), psutil.Process()}
         self.assertEqual(len(s), 1)
 
     def test__all__(self):
@@ -2901,7 +2899,7 @@ class TestExampleScripts(unittest.TestCase):
 
     def assert_syntax(self, exe, args=None):
         exe = os.path.join(EXAMPLES_DIR, exe)
-        with open(exe, 'r') as f:
+        with open(exe) as f:
             src = f.read()
         ast.parse(src)
 
@@ -3004,7 +3002,7 @@ def main():
         tests.append(stc)
 
     for test_class in tests:
-        test_suite.addTest(unittest.makeSuite(test_class))
+        test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(test_class))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
diff --git a/python/py/py/_apipkg.py b/python/py/py/_apipkg.py
index a73b8f6d0b..ae24a8b33a 100644
--- a/python/py/py/_apipkg.py
+++ b/python/py/py/_apipkg.py
@@ -77,7 +77,7 @@ class ApiModule(ModuleType):
                 setattr(self, name, val)
         for name, importspec in importspec.items():
             if isinstance(importspec, dict):
-                subname = '%s.%s' % (self.__name__, name)
+                subname = '{}.{}'.format(self.__name__, name)
                 apimod = ApiModule(subname, importspec, implprefix)
                 sys.modules[subname] = apimod
                 setattr(self, name, apimod)
@@ -89,7 +89,7 @@ class ApiModule(ModuleType):
                     modpath = implprefix + modpath
 
                 if not attrname:
-                    subname = '%s.%s' % (self.__name__, name)
+                    subname = '{}.{}'.format(self.__name__, name)
                     apimod = AliasModule(subname, modpath)
                     sys.modules[subname] = apimod
                     if '.' not in name:
@@ -104,8 +104,8 @@ class ApiModule(ModuleType):
         if hasattr(self, '__file__'):
             l.append('from ' + repr(self.__file__))
         if l:
-            return '<ApiModule %r %s>' % (self.__name__, " ".join(l))
-        return '<ApiModule %r>' % (self.__name__,)
+            return '<ApiModule {!r} {}>'.format(self.__name__, " ".join(l))
+        return '<ApiModule {!r}>'.format(self.__name__)
 
     def __makeattr(self, name):
         """lazily compute value for name or raise AttributeError if unknown."""
@@ -164,7 +164,7 @@ def AliasModule(modname, modpath, attrname=None):
             x = modpath
             if attrname:
                 x += "." + attrname
-            return '<AliasModule %r for %r>' % (modname, x)
+            return '<AliasModule {!r} for {!r}>'.format(modname, x)
 
         def __getattribute__(self, name):
             try:
diff --git a/python/py/py/_builtin.py b/python/py/py/_builtin.py
index 52ee9d79ca..ba30137a15 100644
--- a/python/py/py/_builtin.py
+++ b/python/py/py/_builtin.py
@@ -14,7 +14,7 @@ except NameError:
             raise TypeError("argument to reversed() must be a sequence")
         return reversed_iterator(sequence)
 
-    class reversed_iterator(object):
+    class reversed_iterator:
 
         def __init__(self, seq):
             self.seq = seq
@@ -113,127 +113,60 @@ except NameError:
     def callable(obj):
         return hasattr(obj, "__call__")
 
-if sys.version_info >= (3, 0):
-    exec ("print_ = print ; exec_=exec")
-    import builtins
+exec ("print_ = print ; exec_=exec")
+import builtins
 
-    # some backward compatibility helpers
-    _basestring = str
-    def _totext(obj, encoding=None, errors=None):
-        if isinstance(obj, bytes):
-            if errors is None:
-                obj = obj.decode(encoding)
-            else:
-                obj = obj.decode(encoding, errors)
-        elif not isinstance(obj, str):
-            obj = str(obj)
-        return obj
-
-    def _isbytes(x):
-        return isinstance(x, bytes)
-    def _istext(x):
-        return isinstance(x, str)
-
-    text = str
-    bytes = bytes
-
-
-    def _getimself(function):
-        return getattr(function, '__self__', None)
-
-    def _getfuncdict(function):
-        return getattr(function, "__dict__", None)
-
-    def _getcode(function):
-        return getattr(function, "__code__", None)
-
-    def execfile(fn, globs=None, locs=None):
-        if globs is None:
-            back = sys._getframe(1)
-            globs = back.f_globals
-            locs = back.f_locals
-            del back
-        elif locs is None:
-            locs = globs
-        fp = open(fn, "r")
-        try:
-            source = fp.read()
-        finally:
-            fp.close()
-        co = compile(source, fn, "exec", dont_inherit=True)
-        exec_(co, globs, locs)
-
-else:
-    import __builtin__ as builtins
-    _totext = unicode
-    _basestring = basestring
-    text = unicode
-    bytes = str
-    execfile = execfile
-    callable = callable
-    def _isbytes(x):
-        return isinstance(x, str)
-    def _istext(x):
-        return isinstance(x, unicode)
-
-    def _getimself(function):
-        return getattr(function, 'im_self', None)
+# some backward compatibility helpers
+_basestring = str
+def _totext(obj, encoding=None, errors=None):
+    if isinstance(obj, bytes):
+        if errors is None:
+            obj = obj.decode(encoding)
+        else:
+            obj = obj.decode(encoding, errors)
+    elif not isinstance(obj, str):
+        obj = str(obj)
+    return obj
+
+def _isbytes(x):
+    return isinstance(x, bytes)
+def _istext(x):
+    return isinstance(x, str)
+
+text = str
+bytes = bytes
+
+
+def _getimself(function):
+    return getattr(function, '__self__', None)
+
+def _getfuncdict(function):
+    return getattr(function, "__dict__", None)
+
+def _getcode(function):
+    return getattr(function, "__code__", None)
+
+def execfile(fn, globs=None, locs=None):
+    if globs is None:
+        back = sys._getframe(1)
+        globs = back.f_globals
+        locs = back.f_locals
+        del back
+    elif locs is None:
+        locs = globs
+    fp = open(fn)
+    try:
+        source = fp.read()
+    finally:
+        fp.close()
+    co = compile(source, fn, "exec", dont_inherit=True)
+    exec_(co, globs, locs)
 
-    def _getfuncdict(function):
-        return getattr(function, "__dict__", None)
 
-    def _getcode(function):
-        try:
-            return getattr(function, "__code__")
-        except AttributeError:
-            return getattr(function, "func_code", None)
-
-    def print_(*args, **kwargs):
-        """ minimal backport of py3k print statement. """
-        sep = ' '
-        if 'sep' in kwargs:
-            sep = kwargs.pop('sep')
-        end = '\n'
-        if 'end' in kwargs:
-            end = kwargs.pop('end')
-        file = 'file' in kwargs and kwargs.pop('file') or sys.stdout
-        if kwargs:
-            args = ", ".join([str(x) for x in kwargs])
-            raise TypeError("invalid keyword arguments: %s" % args)
-        at_start = True
-        for x in args:
-            if not at_start:
-                file.write(sep)
-            file.write(str(x))
-            at_start = False
-        file.write(end)
-
-    def exec_(obj, globals=None, locals=None):
-        """ minimal backport of py3k exec statement. """
-        __tracebackhide__ = True
-        if globals is None:
-            frame = sys._getframe(1)
-            globals = frame.f_globals
-            if locals is None:
-                locals = frame.f_locals
-        elif locals is None:
-            locals = globals
-        exec2(obj, globals, locals)
-
-if sys.version_info >= (3, 0):
-    def _reraise(cls, val, tb):
-        __tracebackhide__ = True
-        assert hasattr(val, '__traceback__')
-        raise cls.with_traceback(val, tb)
-else:
-    exec ("""
 def _reraise(cls, val, tb):
     __tracebackhide__ = True
-    raise cls, val, tb
-def exec2(obj, globals, locals):
-    __tracebackhide__ = True
-    exec obj in globals, locals
-""")
+    assert hasattr(val, '__traceback__')
+    raise cls.with_traceback(val, tb)
 
 def _tryimport(*names):
     """ return the first successfully imported module. """
